/**
 * Appcelerator Titanium Mobile
 * Copyright (c) 2009-2015 by Appcelerator, Inc. All Rights Reserved.
 * Licensed under the terms of the Apache Public License
 * Please see the LICENSE included with this distribution for details.
 */

#import "AppcGooglemapsView.h"
#import <GoogleMaps/GoogleMaps.h>

@implementation AppcGooglemapsView {
    GMSMapView *mapView_;
}

-(void)dealloc
{
    NSLog(@"[VIEW LIFECYCLE EVENT] dealloc");
    
    RELEASE_TO_NIL(mapView_);
    
    [super dealloc];
}

-(GMSMapView*)map
{
    if (!mapView_) {
        // Create a GMSCameraPosition that tells the map to display the
        // coordinate -33.86,151.20 at zoom level 6.
        GMSCameraPosition *camera = [GMSCameraPosition cameraWithLatitude:-33.86
                                                                longitude:151.20
                                                                     zoom:6];
        mapView_ = [[GMSMapView mapWithFrame:[self bounds] camera:camera] retain];
        [mapView_ setAutoresizingMask:(UIViewAutoresizingFlexibleHeight|UIViewAutoresizingFlexibleWidth)];
        mapView_.myLocationEnabled = YES;
        //        self.view = mapView_;
        [self addSubview:mapView_];
        
        // Creates a marker in the center of the map.
//        GMSMarker *marker = [[GMSMarker alloc] init];
//        marker.position = CLLocationCoordinate2DMake(-33.86, 151.20);
//        marker.title = @"Sydney";
//        marker.snippet = @"Australia";
//        marker.map = mapView_;
    }
    return mapView_;
}

-(void)didMoveToWindow
{
    if (self.window != nil && mapView_ == nil) {
        [self map];
    }
    [super didMoveToWindow];
}

-(void)frameSizeChanged:(CGRect)frame bounds:(CGRect)bounds
{
    [mapView_ setFrame:bounds];
    //[TiUtils setView:[self map] positionRect:bounds];
}

@end
